#include <iostream>
#include <memory>

using std::ostream;
using std::cout;
using std::endl;

using std::unique_ptr;

using std::move;

struct MyInt{

  MyInt(int i):i_(i){}

  ~MyInt(){
    cout << "Good bye from " << i_ << endl;
  }

  int i_;

};


int main(){

  cout << endl;

  std::unique_ptr<MyInt> uniquePtr1{ new MyInt(1998) };

  cout << "uniquePtr1.get(): " << uniquePtr1.get() << endl;

  unique_ptr<MyInt> uniquePtr2{ move(uniquePtr1) };
  cout << "uniquePtr1.get(): " << uniquePtr1.get() << endl;
  cout << "uniquePtr2.get(): " << uniquePtr2.get() << endl;

  cout << endl;


  {
    unique_ptr<MyInt> localPtr{ new MyInt(2003) };
  }

  cout << endl;

  uniquePtr2.reset(new MyInt(2011));
  MyInt* myInt= uniquePtr2.release();
  delete myInt;

  cout << endl;

  unique_ptr<MyInt> uniquePtr3{ new MyInt(2017) };
  unique_ptr<MyInt> uniquePtr4{ new MyInt(2022) };

  cout << "uniquePtr3.get(): " << uniquePtr3.get() << endl;
  cout << "uniquePtr4.get(): " << uniquePtr4.get() << endl;

  swap(uniquePtr3, uniquePtr4);

  cout << "uniquePtr3.get(): " << uniquePtr3.get() << endl;
  cout << "uniquePtr4.get(): " << uniquePtr4.get() << endl;

  cout << endl;

}
